diff -uwbBpr libfloat/softfloat/bits64/timesoftfloat.c SoftFloat-2a/softfloat/bits64/timesoftfloat.c
--- libfloat/softfloat/bits64/timesoftfloat.c	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/timesoftfloat.c	Mon Sep 20 11:47:03 1999
@@ -865,19 +1221,20 @@ static void time_az_floatx80( floatx80 f
     inputNum = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_floatx80[ inputNum ].low;
         a.high = inputs_floatx80[ inputNum ].high;
-        (void) function( a );
-        ++count;
+            function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_floatx80 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_floatx80[ inputNum ].low;
         a.high = inputs_floatx80[ inputNum ].high;
-        (void) function( a );
+        function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_floatx80 - 1 );
     }
     endClock = clock();
@@ -897,26 +1254,27 @@ static void time_ab_floatx80_z_flag( fla
     inputNumB = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_floatx80[ inputNumA ].low;
         a.high = inputs_floatx80[ inputNumA ].high;
         b.low = inputs_floatx80[ inputNumB ].low;
         b.high = inputs_floatx80[ inputNumB ].high;
-        (void) function( a, b );
-        ++count;
+            function( a, b );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_floatx80 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_floatx80 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNumA = 0;
     inputNumB = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_floatx80[ inputNumA ].low;
         a.high = inputs_floatx80[ inputNumA ].high;
         b.low = inputs_floatx80[ inputNumB ].low;
         b.high = inputs_floatx80[ inputNumB ].high;
-        (void) function( a, b );
+        function( a, b );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_floatx80 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_floatx80 - 1 );
@@ -938,26 +1296,27 @@ static void time_abz_floatx80( floatx80 
     inputNumB = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_floatx80[ inputNumA ].low;
         a.high = inputs_floatx80[ inputNumA ].high;
         b.low = inputs_floatx80[ inputNumB ].low;
         b.high = inputs_floatx80[ inputNumB ].high;
-        (void) function( a, b );
-        ++count;
+            function( a, b );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_floatx80 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_floatx80 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNumA = 0;
     inputNumB = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_floatx80[ inputNumA ].low;
         a.high = inputs_floatx80[ inputNumA ].high;
         b.low = inputs_floatx80[ inputNumB ].low;
         b.high = inputs_floatx80[ inputNumB ].high;
-        (void) function( a, b );
+        function( a, b );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_floatx80 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_floatx80 - 1 );
@@ -967,6 +1326,76 @@ static void time_abz_floatx80( floatx80 
 
 }
 
+static const struct {
+    bits16 high;
+    bits64 low;
+} inputs_floatx80_pos[ numInputs_floatx80 ] = {
+    { 0x403F, LIT64( 0xA9BE15A19C1E8B62 ) },
+    { 0x0000, LIT64( 0x0000000000000000 ) },
+    { 0x75A8, LIT64( 0xE59591E4788957A5 ) },
+    { 0x3FFF, LIT64( 0xFFF0000000000040 ) },
+    { 0x0CD8, LIT64( 0xFC000000000007FE ) },
+    { 0x43BA, LIT64( 0x99A4000000000000 ) },
+    { 0x3FFF, LIT64( 0x8000000000000000 ) },
+    { 0x4081, LIT64( 0x94FBF1BCEB5545F0 ) },
+    { 0x403E, LIT64( 0xFFF0000000002000 ) },
+    { 0x3FFE, LIT64( 0xC860E3C75D224F28 ) },
+    { 0x407E, LIT64( 0xFC00000FFFFFFFFE ) },
+    { 0x737A, LIT64( 0x800000007FFDFFFE ) },
+    { 0x4044, LIT64( 0xFFFFFF80000FFFFF ) },
+    { 0x3BFE, LIT64( 0x8000040000001FFE ) },
+    { 0x4002, LIT64( 0xFF80000000000020 ) },
+    { 0x5E8D, LIT64( 0xFFFFFFFFFFE00004 ) },
+    { 0x4004, LIT64( 0x8000000000003FFB ) },
+    { 0x407F, LIT64( 0x800000000003FFFE ) },
+    { 0x4000, LIT64( 0xA459EE6A5C16CA55 ) },
+    { 0x0003, LIT64( 0xC42CBF7399AEEB94 ) },
+    { 0x3F7F, LIT64( 0xF800000000000006 ) },
+    { 0x407F, LIT64( 0xBF56BE8871F28FEA ) },
+    { 0x407E, LIT64( 0xFFFF77FFFFFFFFFE ) },
+    { 0x2DC9, LIT64( 0x8000000FFFFFFFDE ) },
+    { 0x4001, LIT64( 0xEFF7FFFFFFFFFFFF ) },
+    { 0x4001, LIT64( 0xBE84F30125C497A6 ) },
+    { 0x406B, LIT64( 0xEFFFFFFFFFFFFFFF ) },
+    { 0x4080, LIT64( 0xFFFFFFFFBFFFFFFF ) },
+    { 0x07E9, LIT64( 0x81FFFFFFFFFFFBFF ) },
+    { 0x263F, LIT64( 0x801FFFFFFEFFFFFE ) },
+    { 0x403C, LIT64( 0x801FFFFFFFF7FFFF ) },
+    { 0x4018, LIT64( 0x8000000000080003 ) }
+};
+
+static void time_az_floatx80_pos( floatx80 function( floatx80 ) )
+{
+    clock_t startClock, endClock;
+    int32 count, i;
+    int8 inputNum;
+    floatx80 a;
+
+    count = 0;
+    inputNum = 0;
+    startClock = clock();
+    do {
+        for ( i = minIterations; i; --i ) {
+            a.low = inputs_floatx80_pos[ inputNum ].low;
+            a.high = inputs_floatx80_pos[ inputNum ].high;
+            function( a );
+            inputNum = ( inputNum + 1 ) & ( numInputs_floatx80 - 1 );
+        }
+        count += minIterations;
+    } while ( clock() - startClock < CLOCKS_PER_SEC );
+    inputNum = 0;
+    startClock = clock();
+    for ( i = count; i; --i ) {
+        a.low = inputs_floatx80_pos[ inputNum ].low;
+        a.high = inputs_floatx80_pos[ inputNum ].high;
+        function( a );
+        inputNum = ( inputNum + 1 ) & ( numInputs_floatx80 - 1 );
+    }
+    endClock = clock();
+    reportTime( count, endClock - startClock );
+
+}
+
 #endif
 
 #ifdef FLOAT128
@@ -1023,19 +1452,52 @@ static void time_a_float128_z_int32( int
     inputNum = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_float128[ inputNum ].low;
         a.high = inputs_float128[ inputNum ].high;
-        (void) function( a );
-        ++count;
+            function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float128 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_float128[ inputNum ].low;
         a.high = inputs_float128[ inputNum ].high;
-        (void) function( a );
+        function( a );
+        inputNum = ( inputNum + 1 ) & ( numInputs_float128 - 1 );
+    }
+    endClock = clock();
+    reportTime( count, endClock - startClock );
+
+}
+
+static void time_a_float128_z_int64( int64 function( float128 ) )
+{
+    clock_t startClock, endClock;
+    int32 count, i;
+    int8 inputNum;
+    float128 a;
+
+    count = 0;
+    inputNum = 0;
+    startClock = clock();
+    do {
+        for ( i = minIterations; i; --i ) {
+            a.low = inputs_float128[ inputNum ].low;
+            a.high = inputs_float128[ inputNum ].high;
+            function( a );
+            inputNum = ( inputNum + 1 ) & ( numInputs_float128 - 1 );
+        }
+        count += minIterations;
+    } while ( clock() - startClock < CLOCKS_PER_SEC );
+    inputNum = 0;
+    startClock = clock();
+    for ( i = count; i; --i ) {
+        a.low = inputs_float128[ inputNum ].low;
+        a.high = inputs_float128[ inputNum ].high;
+        function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float128 - 1 );
     }
     endClock = clock();
@@ -1054,19 +1516,20 @@ static void time_a_float128_z_float32( f
     inputNum = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_float128[ inputNum ].low;
         a.high = inputs_float128[ inputNum ].high;
-        (void) function( a );
-        ++count;
+            function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float128 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_float128[ inputNum ].low;
         a.high = inputs_float128[ inputNum ].high;
-        (void) function( a );
+        function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float128 - 1 );
     }
     endClock = clock();
@@ -1085,19 +1548,20 @@ static void time_a_float128_z_float64( f
     inputNum = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_float128[ inputNum ].low;
         a.high = inputs_float128[ inputNum ].high;
-        (void) function( a );
-        ++count;
+            function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float128 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_float128[ inputNum ].low;
         a.high = inputs_float128[ inputNum ].high;
-        (void) function( a );
+        function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float128 - 1 );
     }
     endClock = clock();
@@ -1118,19 +1582,20 @@ static void time_a_float128_z_floatx80( 
     inputNum = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_float128[ inputNum ].low;
         a.high = inputs_float128[ inputNum ].high;
-        (void) function( a );
-        ++count;
+            function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float128 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_float128[ inputNum ].low;
         a.high = inputs_float128[ inputNum ].high;
-        (void) function( a );
+        function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float128 - 1 );
     }
     endClock = clock();
@@ -1151,19 +1616,20 @@ static void time_az_float128( float128 f
     inputNum = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_float128[ inputNum ].low;
         a.high = inputs_float128[ inputNum ].high;
-        (void) function( a );
-        ++count;
+            function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float128 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_float128[ inputNum ].low;
         a.high = inputs_float128[ inputNum ].high;
-        (void) function( a );
+        function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float128 - 1 );
     }
     endClock = clock();
@@ -1183,26 +1649,27 @@ static void time_ab_float128_z_flag( fla
     inputNumB = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_float128[ inputNumA ].low;
         a.high = inputs_float128[ inputNumA ].high;
         b.low = inputs_float128[ inputNumB ].low;
         b.high = inputs_float128[ inputNumB ].high;
-        (void) function( a, b );
-        ++count;
+            function( a, b );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float128 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_float128 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNumA = 0;
     inputNumB = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_float128[ inputNumA ].low;
         a.high = inputs_float128[ inputNumA ].high;
         b.low = inputs_float128[ inputNumB ].low;
         b.high = inputs_float128[ inputNumB ].high;
-        (void) function( a, b );
+        function( a, b );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float128 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_float128 - 1 );
@@ -1224,26 +1691,27 @@ static void time_abz_float128( float128 
     inputNumB = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_float128[ inputNumA ].low;
         a.high = inputs_float128[ inputNumA ].high;
         b.low = inputs_float128[ inputNumB ].low;
         b.high = inputs_float128[ inputNumB ].high;
-        (void) function( a, b );
-        ++count;
+            function( a, b );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float128 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_float128 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNumA = 0;
     inputNumB = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_float128[ inputNumA ].low;
         a.high = inputs_float128[ inputNumA ].high;
         b.low = inputs_float128[ inputNumB ].low;
         b.high = inputs_float128[ inputNumB ].high;
-        (void) function( a, b );
+        function( a, b );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float128 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_float128 - 1 );
@@ -1253,6 +1721,75 @@ static void time_abz_float128( float128 
 
 }
 
+static const struct {
+    bits64 high, low;
+} inputs_float128_pos[ numInputs_float128 ] = {
+    { LIT64( 0x3FDA200000100000 ), LIT64( 0x0000000000000000 ) },
+    { LIT64( 0x3FFF000000000000 ), LIT64( 0x0000000000000000 ) },
+    { LIT64( 0x05F14776190C8306 ), LIT64( 0xD8715F4E3D54BB92 ) },
+    { LIT64( 0x72B00000007FFFFF ), LIT64( 0xFFFFFFFFFFF7FFFF ) },
+    { LIT64( 0x0000000000000000 ), LIT64( 0x0000000000000000 ) },
+    { LIT64( 0x3FFFFFFFFFE00000 ), LIT64( 0x0000008000000000 ) },
+    { LIT64( 0x407F1719CE722F3E ), LIT64( 0xDA6B3FE5FF29425B ) },
+    { LIT64( 0x43FFFF8000000000 ), LIT64( 0x0000000000400000 ) },
+    { LIT64( 0x401E000000000100 ), LIT64( 0x0000000000002000 ) },
+    { LIT64( 0x3FFED71DACDA8E47 ), LIT64( 0x4860E3C75D224F28 ) },
+    { LIT64( 0x3F7ECFC1E90647D1 ), LIT64( 0x7A124FE55623EE44 ) },
+    { LIT64( 0x0DF7007FFFFFFFFF ), LIT64( 0xFFFFFFFFEFFFFFFF ) },
+    { LIT64( 0x3FE5FFEFFFFFFFFF ), LIT64( 0xFFFFFFFFFFFFEFFF ) },
+    { LIT64( 0x403FFFFFFFFFFFFF ), LIT64( 0xFFFFFFFFFFFFFBFE ) },
+    { LIT64( 0x3FFB2FBF7399AFEB ), LIT64( 0xA459EE6A5C16CA55 ) },
+    { LIT64( 0x3DB8FFFFFFFFFFFC ), LIT64( 0x0000000000000400 ) },
+    { LIT64( 0x3FC8FFDFFFFFFFFF ), LIT64( 0xFFFFFFFFF0000000 ) },
+    { LIT64( 0x3FFBFFFFFFDFFFFF ), LIT64( 0xFFF8000000000000 ) },
+    { LIT64( 0x407043C11737BE84 ), LIT64( 0xDDD58212ADC937F4 ) },
+    { LIT64( 0x0001000000000000 ), LIT64( 0x0000001000000001 ) },
+    { LIT64( 0x4036FFFFFFFFFFFF ), LIT64( 0xFE40000000000000 ) },
+    { LIT64( 0x4002FFFFFE000002 ), LIT64( 0x0000000000000000 ) },
+    { LIT64( 0x4000C3FEDE897773 ), LIT64( 0x326AC4FD8EFBE6DC ) },
+    { LIT64( 0x3FFF0000000FFFFF ), LIT64( 0xFFFFFE0000000000 ) },
+    { LIT64( 0x62C3E502146E426D ), LIT64( 0x43F3CAA0DC7DF1A0 ) },
+    { LIT64( 0x35CBD32E52BB570E ), LIT64( 0xBCC477CB11C6236C ) },
+    { LIT64( 0x6228FFFFFFC00000 ), LIT64( 0x0000000000000000 ) },
+    { LIT64( 0x3F80000000000000 ), LIT64( 0x0000000080000008 ) },
+    { LIT64( 0x41AFFFDFFFFFFFFF ), LIT64( 0xFFFC000000000000 ) },
+    { LIT64( 0x496F000000000000 ), LIT64( 0x00000001FFFBFFFF ) },
+    { LIT64( 0x3DE09BFE7923A338 ), LIT64( 0xBCC8FBBD7CEC1F4F ) },
+    { LIT64( 0x401CFFFFFFFFFFFF ), LIT64( 0xFFFFFFFEFFFFFF80 ) }
+};
+
+static void time_az_float128_pos( float128 function( float128 ) )
+{
+    clock_t startClock, endClock;
+    int32 count, i;
+    int8 inputNum;
+    float128 a;
+
+    count = 0;
+    inputNum = 0;
+    startClock = clock();
+    do {
+        for ( i = minIterations; i; --i ) {
+            a.low = inputs_float128_pos[ inputNum ].low;
+            a.high = inputs_float128_pos[ inputNum ].high;
+            function( a );
+            inputNum = ( inputNum + 1 ) & ( numInputs_float128 - 1 );
+        }
+        count += minIterations;
+    } while ( clock() - startClock < CLOCKS_PER_SEC );
+    inputNum = 0;
+    startClock = clock();
+    for ( i = count; i; --i ) {
+        a.low = inputs_float128_pos[ inputNum ].low;
+        a.high = inputs_float128_pos[ inputNum ].high;
+        function( a );
+        inputNum = ( inputNum + 1 ) & ( numInputs_float128 - 1 );
+    }
+    endClock = clock();
+    reportTime( count, endClock - startClock );
+
+}
+
 #endif
 
 enum {
@@ -1264,8 +1801,18 @@ enum {
 #ifdef FLOAT128
     INT32_TO_FLOAT128,
 #endif
+    INT64_TO_FLOAT32,
+    INT64_TO_FLOAT64,
+#ifdef FLOATX80
+    INT64_TO_FLOATX80,
+#endif
+#ifdef FLOAT128
+    INT64_TO_FLOAT128,
+#endif
     FLOAT32_TO_INT32,
     FLOAT32_TO_INT32_ROUND_TO_ZERO,
+    FLOAT32_TO_INT64,
+    FLOAT32_TO_INT64_ROUND_TO_ZERO,
     FLOAT32_TO_FLOAT64,
 #ifdef FLOATX80
     FLOAT32_TO_FLOATX80,
@@ -1288,6 +1835,8 @@ enum {
     FLOAT32_LT_QUIET,
     FLOAT64_TO_INT32,
     FLOAT64_TO_INT32_ROUND_TO_ZERO,
+    FLOAT64_TO_INT64,
+    FLOAT64_TO_INT64_ROUND_TO_ZERO,
     FLOAT64_TO_FLOAT32,
 #ifdef FLOATX80
     FLOAT64_TO_FLOATX80,
@@ -1311,6 +1860,8 @@ enum {
 #ifdef FLOATX80
     FLOATX80_TO_INT32,
     FLOATX80_TO_INT32_ROUND_TO_ZERO,
+    FLOATX80_TO_INT64,
+    FLOATX80_TO_INT64_ROUND_TO_ZERO,
     FLOATX80_TO_FLOAT32,
     FLOATX80_TO_FLOAT64,
 #ifdef FLOAT128
@@ -1333,6 +1884,8 @@ enum {
 #ifdef FLOAT128
     FLOAT128_TO_INT32,
     FLOAT128_TO_INT32_ROUND_TO_ZERO,
+    FLOAT128_TO_INT64,
+    FLOAT128_TO_INT64_ROUND_TO_ZERO,
     FLOAT128_TO_FLOAT32,
     FLOAT128_TO_FLOAT64,
 #ifdef FLOATX80
@@ -1370,8 +1923,18 @@ static struct {
 #ifdef FLOAT128
     { "int32_to_float128",               1, FALSE, FALSE, FALSE, FALSE },
 #endif
+    { "int64_to_float32",                1, FALSE, TRUE,  FALSE, FALSE },
+    { "int64_to_float64",                1, FALSE, TRUE,  FALSE, FALSE },
+#ifdef FLOATX80
+    { "int64_to_floatx80",               1, FALSE, FALSE, FALSE, FALSE },
+#endif
+#ifdef FLOAT128
+    { "int64_to_float128",               1, FALSE, FALSE, FALSE, FALSE },
+#endif
     { "float32_to_int32",                1, FALSE, TRUE,  FALSE, FALSE },
     { "float32_to_int32_round_to_zero",  1, FALSE, FALSE, FALSE, FALSE },
+    { "float32_to_int64",                1, FALSE, TRUE,  FALSE, FALSE },
+    { "float32_to_int64_round_to_zero",  1, FALSE, FALSE, FALSE, FALSE },
     { "float32_to_float64",              1, FALSE, FALSE, FALSE, FALSE },
 #ifdef FLOATX80
     { "float32_to_floatx80",             1, FALSE, FALSE, FALSE, FALSE },
@@ -1394,6 +1957,8 @@ static struct {
     { "float32_lt_quiet",                2, FALSE, FALSE, FALSE, FALSE },
     { "float64_to_int32",                1, FALSE, TRUE,  FALSE, FALSE },
     { "float64_to_int32_round_to_zero",  1, FALSE, FALSE, FALSE, FALSE },
+    { "float64_to_int64",                1, FALSE, TRUE,  FALSE, FALSE },
+    { "float64_to_int64_round_to_zero",  1, FALSE, FALSE, FALSE, FALSE },
     { "float64_to_float32",              1, FALSE, TRUE,  TRUE,  FALSE },
 #ifdef FLOATX80
     { "float64_to_floatx80",             1, FALSE, FALSE, FALSE, FALSE },
@@ -1417,6 +1982,8 @@ static struct {
 #ifdef FLOATX80
     { "floatx80_to_int32",               1, FALSE, TRUE,  FALSE, FALSE },
     { "floatx80_to_int32_round_to_zero", 1, FALSE, FALSE, FALSE, FALSE },
+    { "floatx80_to_int64",               1, FALSE, TRUE,  FALSE, FALSE },
+    { "floatx80_to_int64_round_to_zero", 1, FALSE, FALSE, FALSE, FALSE },
     { "floatx80_to_float32",             1, FALSE, TRUE,  TRUE,  FALSE },
     { "floatx80_to_float64",             1, FALSE, TRUE,  TRUE,  FALSE },
 #ifdef FLOAT128
@@ -1439,6 +2006,8 @@ static struct {
 #ifdef FLOAT128
     { "float128_to_int32",               1, FALSE, TRUE,  FALSE, FALSE },
     { "float128_to_int32_round_to_zero", 1, FALSE, FALSE, FALSE, FALSE },
+    { "float128_to_int64",               1, FALSE, TRUE,  FALSE, FALSE },
+    { "float128_to_int64_round_to_zero", 1, FALSE, FALSE, FALSE, FALSE },
     { "float128_to_float32",             1, FALSE, TRUE,  TRUE,  FALSE },
     { "float128_to_float64",             1, FALSE, TRUE,  TRUE,  FALSE },
 #ifdef FLOATX80
@@ -1555,12 +2124,34 @@ static void
         time_a_int32_z_float128( int32_to_float128 );
         break;
 #endif
+     case INT64_TO_FLOAT32:
+        time_a_int64_z_float32( int64_to_float32 );
+        break;
+     case INT64_TO_FLOAT64:
+        time_a_int64_z_float64( int64_to_float64 );
+        break;
+#ifdef FLOATX80
+     case INT64_TO_FLOATX80:
+        time_a_int64_z_floatx80( int64_to_floatx80 );
+        break;
+#endif
+#ifdef FLOAT128
+     case INT64_TO_FLOAT128:
+        time_a_int64_z_float128( int64_to_float128 );
+        break;
+#endif
      case FLOAT32_TO_INT32:
         time_a_float32_z_int32( float32_to_int32 );
         break;
      case FLOAT32_TO_INT32_ROUND_TO_ZERO:
         time_a_float32_z_int32( float32_to_int32_round_to_zero );
         break;
+     case FLOAT32_TO_INT64:
+        time_a_float32_z_int64( float32_to_int64 );
+        break;
+     case FLOAT32_TO_INT64_ROUND_TO_ZERO:
+        time_a_float32_z_int64( float32_to_int64_round_to_zero );
+        break;
      case FLOAT32_TO_FLOAT64:
         time_a_float32_z_float64( float32_to_float64 );
         break;
@@ -1593,7 +2184,7 @@ static void
         time_abz_float32( float32_rem );
         break;
      case FLOAT32_SQRT:
-        time_az_float32( float32_sqrt );
+        time_az_float32_pos( float32_sqrt );
         break;
      case FLOAT32_EQ:
         time_ab_float32_z_flag( float32_eq );
@@ -1619,6 +2210,12 @@ static void
      case FLOAT64_TO_INT32_ROUND_TO_ZERO:
         time_a_float64_z_int32( float64_to_int32_round_to_zero );
         break;
+     case FLOAT64_TO_INT64:
+        time_a_float64_z_int64( float64_to_int64 );
+        break;
+     case FLOAT64_TO_INT64_ROUND_TO_ZERO:
+        time_a_float64_z_int64( float64_to_int64_round_to_zero );
+        break;
      case FLOAT64_TO_FLOAT32:
         time_a_float64_z_float32( float64_to_float32 );
         break;
@@ -1651,7 +2248,7 @@ static void
         time_abz_float64( float64_rem );
         break;
      case FLOAT64_SQRT:
-        time_az_float64( float64_sqrt );
+        time_az_float64_pos( float64_sqrt );
         break;
      case FLOAT64_EQ:
         time_ab_float64_z_flag( float64_eq );
@@ -1678,6 +2275,12 @@ static void
      case FLOATX80_TO_INT32_ROUND_TO_ZERO:
         time_a_floatx80_z_int32( floatx80_to_int32_round_to_zero );
         break;
+     case FLOATX80_TO_INT64:
+        time_a_floatx80_z_int64( floatx80_to_int64 );
+        break;
+     case FLOATX80_TO_INT64_ROUND_TO_ZERO:
+        time_a_floatx80_z_int64( floatx80_to_int64_round_to_zero );
+        break;
      case FLOATX80_TO_FLOAT32:
         time_a_floatx80_z_float32( floatx80_to_float32 );
         break;
@@ -1708,7 +2311,7 @@ static void
         time_abz_floatx80( floatx80_rem );
         break;
      case FLOATX80_SQRT:
-        time_az_floatx80( floatx80_sqrt );
+        time_az_floatx80_pos( floatx80_sqrt );
         break;
      case FLOATX80_EQ:
         time_ab_floatx80_z_flag( floatx80_eq );
@@ -1736,6 +2339,12 @@ static void
      case FLOAT128_TO_INT32_ROUND_TO_ZERO:
         time_a_float128_z_int32( float128_to_int32_round_to_zero );
         break;
+     case FLOAT128_TO_INT64:
+        time_a_float128_z_int64( float128_to_int64 );
+        break;
+     case FLOAT128_TO_INT64_ROUND_TO_ZERO:
+        time_a_float128_z_int64( float128_to_int64_round_to_zero );
+        break;
      case FLOAT128_TO_FLOAT32:
         time_a_float128_z_float32( float128_to_float32 );
         break;
@@ -1766,7 +2375,7 @@ static void
         time_abz_float128( float128_rem );
         break;
      case FLOAT128_SQRT:
-        time_az_float128( float128_sqrt );
+        time_az_float128_pos( float128_sqrt );
         break;
      case FLOAT128_EQ:
         time_ab_float128_z_flag( float128_eq );
@@ -1884,7 +2493,7 @@ main( int argc, char **argv )
         if ( strcmp( argPtr, "help" ) == 0 ) {
  writeHelpMessage:
             fputs(
-"usage: timesoftfloat [<option>...] <function>\n"
+"timesoftfloat [<option>...] <function>\n"
 "  <option>:  (* is default)\n"
 "    -help            --Write this message and exit.\n"
 #ifdef FLOATX80
@@ -1902,9 +2511,12 @@ main( int argc, char **argv )
 "    int32_to_<float>                 <float>_add   <float>_eq\n"
 "    <float>_to_int32                 <float>_sub   <float>_le\n"
 "    <float>_to_int32_round_to_zero   <float>_mul   <float>_lt\n"
-"    <float>_to_<float>               <float>_div   <float>_eq_signaling\n"
-"    <float>_round_to_int             <float>_rem   <float>_le_quiet\n"
-"    <float>_sqrt                                   <float>_lt_quiet\n"
+"    int64_to_<float>                 <float>_div   <float>_eq_signaling\n"
+"    <float>_to_int64                 <float>_rem   <float>_le_quiet\n"
+"    <float>_to_int64_round_to_zero                 <float>_lt_quiet\n"
+"    <float>_to_<float>\n"
+"    <float>_round_to_int\n"
+"    <float>_sqrt\n"
 "    -all1            --All 1-operand functions.\n"
 "    -all2            --All 2-operand functions.\n"
 "    -all             --All functions.\n"
Only in SoftFloat-2a/softfloat: softfloat-history.txt
